package de.hdm_stuttgart.battlearena.Persistance.Classes;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.FileReader;
import java.io.FileWriter;
import java.lang.reflect.Type;
import java.util.ArrayList;

public class GsonHandler {
    Gson gson = new Gson();

    private static final Logger log = LogManager.getLogger(GsonHandler.class);
    Type mapDataType = new TypeToken<ArrayList<MapData>>(){}.getType();

    public ArrayList<MapData> loadMaps() throws RuntimeException{
        try (FileReader reader = new FileReader("src/main/resources/maps/localMaps.json")) {
            ArrayList<MapData> maps = new ArrayList<MapData>();
            maps = gson.fromJson(reader, mapDataType);
            log.info("GSON - Maps successfully loaded from JSON");
            return maps;
        } catch (Exception e) {
            log.info(e);
            log.info("GSON - Loading Maps from JSON failed");
            throw new RuntimeException("Error Loading Maps!");
        }
    }

    public void updateMaps(ArrayList<MapData> maps) {
        try (FileWriter writer = new FileWriter("src/main/resources/maps/localMaps.json")) {
            gson.toJson(maps, writer);
            log.info("GSON - Maps successfully written to JSON");
        } catch (
                Exception e) {
            log.info(e);
            log.info("GSON - Saving SingleBookings to JSON failed");
        }
    }
}
