package de.hdm_stuttgart.battlearena.Persistance.Classes;

import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedHashMap;

public interface IDataBase {

    //connection-Methods
    Connection connect() throws IOException, SQLException;


    //CRUD Operations

    //Create Operations
    void createNewPlayer(String playerName) throws SQLException, IOException;

    void createMap(String name, int length, int width, String mapData) throws SQLException, IOException;

    //Read-operations
    LinkedHashMap<String, String> getMapNames() throws SQLException, IOException;
    String getMapByID(String ID) throws SQLException, IOException;
    String getMapSizeByID(String ID) throws SQLException, IOException;



    ResultSet getStatistics(String playerName) throws SQLException, IOException;

    //Update-operations
    void updateMap(String mapID , String mapName, String mapData) throws SQLException, IOException;

    void updatePlayerName(String playerNameNew, String PlayerNameOld) throws SQLException, IOException;

    void updatePlayerStatistics(String playerName, int gamesWon, int gamesLost, int kills, int deaths, int blocksDestroyed, int gameTime) throws SQLException, IOException;


    //Delete-operations
    void deletePlayer(String playerName) throws IOException, SQLException;
    void deleteMap(String mapID) throws SQLException, IOException;
}
