package de.hdm_stuttgart.battlearena.Persistance.Classes;

import de.hdm_stuttgart.battlearena.Exceptions.ParserError;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class MapData {
    private static final Logger log = LogManager.getLogger(Persistence.class);

    private String mapID;
    private String mapName;
    private int mapHeight;
    private int mapWidth;
    private String mapData;

    protected MapData(String mapID, String mapName, String mapSize, String mapData) {
        try {
            this.mapID = mapID;
            this.mapName = mapName;
            this.mapData = mapData;

            sizeParser(mapSize);
        }
        catch (Exception ParserError){
            log.error(ParserError);
        }
    }

    public String getMapID() {
        return mapID;
    }

    public String getMapName() {
        return mapName;
    }

    public int getMapHeight() {
        return mapHeight;
    }

    public int getMapWidth() {
        return mapWidth;
    }

    public String getMapData() {
        return mapData;
    }

    private void sizeParser(String mapSize) throws ParserError {
        try {
            if (mapSize.length() < 3) {
                throw new ParserError("Incomplete data");
            }

            if (mapSize.length() % 2 == 0) {
                throw new ParserError("Width and height don't match!");
            }

            boolean noX = true;
            for (int i = 0; i < mapSize.length(); i++) {
                if (mapSize.charAt(i) == 'x' | mapSize.charAt(i) == 'X') {
                    noX = false;
                    break;
                }
            }
            if (noX) {
                throw new ParserError("X divider missing!");
            }

            int whereX = 0;
            for (int i = 0; i < mapSize.length(); i++) {
                if (mapSize.charAt(i) == 'x' | mapSize.charAt(i) == 'X') {
                    whereX = i;
                    break;
                }
            }

            mapHeight = Integer.parseInt(mapSize.substring(0, whereX));
            mapWidth = Integer.parseInt(mapSize.substring(whereX));

        }
        catch (Exception e){
            log.error(e);
            throw new ParserError("Parser error!");
        }

    }
}
